<?php

    /**
    * Project : Technical Project Manager (IEEE like)
    *
    * This screen show tasks plan grouped by worktype.
    *
    * @package mod-techproject
    * @category mod
    * @author Valery Fremaux (France) (admin@www.ethnoinformatique.fr)
    * @date 2008/03/03
    * @version phase1
    * @contributors LUU Tao Meng, So Gerard (parts of treelib.php), Guillaume Magnien, Olivier Petit
    * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
    */

    $TIMEUNITS = array(get_string('unset','techproject'),get_string('hours','techproject'),get_string('halfdays','techproject'),get_string('days','techproject'));
    
    if (!groupmode($project->course, $cm)){
        $groupusers = get_course_users($project->course);
    } else {
        $groupusers = get_group_users($currentGroupId);
    }
    
    // get tasks by worktype
    $query = "
       SELECT
          t.*
       FROM
          {$CFG->prefix}techproject_task as t
       LEFT JOIN
          {$CFG->prefix}techproject_worktype as wt
       ON 
          wt.worktype = t.worktype
       WHERE
          t.projectId = {$project->id} AND
          t.groupId = {$currentGroupId}
       ORDER BY
          wt.id ASC
    ";
    if ($tasks = get_records_sql($query)){
    ?>
    <script type="text/javascript">
    function sendgroupdata(){
        document.groupopform.submit();
    }
    </script>
    <form name="groupopform" action="view.php" method="post">
    <input type="hidden" name="id" value="<?php p($cm->id) ?>" />
    <input type="hidden" name="work" value="groupcmd" />
    <input type="hidden" name="view" value="tasks" />
    <?php    
        foreach($tasks as $aTask){
            $sortedtasks[$aTask->worktype][] = $aTask;
        }
        
        foreach(array_keys($sortedtasks) as $aWorktype){
        	$hidesub = "<a href=\"javascript:toggle('{$aWorktype}','sub{$aWorktype}');\"><img name=\"img{$aWorktype}\" src=\"{$CFG->pixpath}/p/switch_minus.gif\" alt=\"collapse\" style=\"background-color : #E0E0E0\" /></a>";
    
            $theWorktype = techproject_get_option_by_key('techproject_worktype', $project->id, 'worktype', $aWorktype);
            if ($aWorktype == ''){
                 $worktypeicon = '';
                 $theWorktype->label = format_text(get_string('untypedtasks', 'techproject'), FORMAT_HTML)."</span>";
            } else {
                 $worktypeicon = "<img src=\"{$CFG->pixpath}/p/{$theWorktype->worktype}.gif\" title=\"{$theWorktype->description}\" style=\"background-color : #F0F0F0\" />";
            }
            print_simple_box($hidesub.' '.$worktypeicon.' <span class="worktypesheadingcontent">'.$theWorktype->label.'</span>', 'center', '100%', 'white', 4, 'worktypesbox');
            echo "<div id=\"sub{$aWorktype}\">";
            foreach($sortedtasks[$aWorktype] as $aTask){
                techproject_print_single_task($aTask, $project, $currentGroupId, $cm->id, count($sortedtasks[$aWorktype]), 'SHORT_WITHOUT_TYPE');
            }
            echo '</div>';
        }
        echo '<p>';
    	techproject_print_group_commands();
        echo '</p>';
    ?>
    </form>
<?php
    } else {
       print_simple_box(get_string('notasks', 'techproject'), 'center', '70%');
    }
?>